#include<iostream>
#include<assert.h>
#include<vector>
#define MAXN 100000
using namespace std;
vector <long long int> a[MAXN];
vector <long long int> path,cycle;
bool used[MAXN];
bool find_cycle (long long int vr, long long int fath) {
    used[vr]=true;
    path.push_back(vr);
    for (auto to : a[vr]) {
        if (to==fath) continue;
        if (used[to]==true) {
            for (int i=path.size()-1; i>=0; i--) {
                cycle.push_back(path[i]);
                if (path[i]==to) break;
            }
            return true;
        }
        if (find_cycle(to,vr)==true) return true;
    }
    path.pop_back();
    return false;
}
vector <long long int> edges1[MAXN],edges2[MAXN];
void find_edges (long long int vr, long long int fath, vector <long long int>& banned) {
    for (auto to : a[vr]) {
        if (to==fath) continue;
        bool flag=false;
        for (auto b : banned) {
            if (to==b) {
                flag=true;
                break;
            }
        }
        if (flag==true) continue;
        edges1[vr].push_back(to);
        find_edges(to,vr,banned);
        //cout << vr+1 << " " << to+1 << endl ;
    }
}

long long int c[MAXN],balance[MAXN],needed[MAXN];
long long int ans[MAXN],ans2[MAXN];
void find_balance () {
    long long int sz=cycle.size();
    for (long long int i=0; i<sz; i++) {
        long long int vr=cycle[i];
        balance[vr]=c[vr]+(ans[vr]+ans2[vr])*a[vr].size();
        for (auto to : a[vr]) {
            balance[vr]-=(ans[to]+ans2[to]);
        }
    }
}
long long int dfs (long long int vr, bool start, long long int sign, vector <long long int> edges[], long long int c[]) {
    needed[vr]=0;
    if ((sign>0)&&(c[vr]>0)) needed[vr]+=c[vr];
    else if ((sign<0)&&(c[vr]<0)&&(start==false)) needed[vr]+=(-c[vr]);
    long long int sum=0;
    for (auto to : edges[vr]) {
        sum+=dfs(to,false,sign,edges,c);
        if (start==false) needed[vr]+=needed[to];
    }
    sum+=needed[vr];
    return sum;
}
void dfs2 (long long int vr, long long int cnt, vector <long long int> edges[], long long int ans[]) {
    cnt-=needed[vr];
    ans[vr]+=cnt;
    for (auto to : edges[vr]) {
        dfs2(to,cnt,edges,ans);
    }
}
void dfs3 (long long int vr, long long int total, vector <long long int> edges[], long long int ans[]) {
    total+=needed[vr];
    ans[vr]+=total;
    for (auto to : edges[vr]) {
        dfs3(to,total,edges,ans);
    }
}
void dfs4 (long long int vr, long long int add) {
    ans[vr]+=add;
    for (auto to : edges1[vr]) {
        dfs4(to,add);
    }
}
long long int tmp[MAXN];
void output_current (long long int n) {
    for (long long int i=0; i<n; i++) {
        long long int val=c[i]+(ans[i]+ans2[i])*a[i].size();
        for (auto to : a[i]) {
            val-=(ans[to]+ans2[to]);
        }
        cout << val << " ";
    }
    cout << endl ;
}
void output_cycle (long long int n) {
    int sz=cycle.size();
    for (int i=0; i<sz; i++) {
        int vr=cycle[i];
        long long int val=balance[vr]+ans2[vr]*2;
        int nxt=(i+1)%sz,prv=(i-1+sz)%sz;
        if (nxt!=i) val-=ans2[cycle[nxt]];
        if (prv!=i) val-=ans2[cycle[prv]];
        cout << val << " ";
    }
    cout << endl ;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    long long int n,m;
    cin >> n >> m ;
    long long int sum=0;
    for (long long int i=0; i<n; i++) {
        cin >> c[i] ;
        sum+=c[i];
    }
    if (sum<0) {
        cout << "Impossible\n";
        return 0;
    }
    for (long long int i=0; i<m; i++) {
        long long int x,y;
        cin >> x >> y ;
        x--; y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    find_cycle(0,-1);
    if (cycle.size()==0) cycle.push_back(0);
    long long int sz=cycle.size();
    for (long long int i=0; i<sz; i++) {
        vector <long long int> banned;
        if ((i+1)%sz!=i) banned.push_back(cycle[(i+1)%sz]);
        if ((i-1+sz)%sz!=i) banned.push_back(cycle[(i-1+sz)%sz]);
        find_edges(cycle[i],-1,banned);
    }
    for (long long int i=0; i<sz-1; i++) {
        edges2[cycle[i]].push_back(cycle[i+1]);
    }
    for (auto vr : cycle) {
        long long int total=dfs(vr,true,+1,edges1,c);
        dfs2(vr,total,edges1,ans);
        dfs(vr,true,-1,edges1,c);
    }
    //output_current(n);

    find_balance();
    for (auto vr : cycle) {
        for (auto to : edges1[vr]) {
            balance[vr]-=needed[to];
            tmp[vr]+=needed[to];
        }
        //cout << tmp[vr] << " ";
    }
    long long int total=dfs(cycle[0],true,+1,edges2,balance);
    dfs2(cycle[0],total,edges2,ans2);
    //output_cycle(n);
    dfs(cycle[0],true,-1,edges2,balance);
    dfs3(cycle[0],0,edges2,ans2);
    //output_cycle(n);
    for (auto vr : cycle) {
        dfs4(vr,ans2[vr]);
        ans2[vr]=0;
    }
    //output_current(n);
    find_balance();
    for (auto vr : cycle) {
        balance[vr]-=tmp[vr];
    }
    if (cycle.size()>=2) {
        for (long long int i=1; i<sz-1; i++) {
            //cout << i << " " << balance[cycle[i]] << endl ;
            assert(balance[cycle[i]]==0);
        }
    }
    if ((sum==0)&&(balance[cycle[0]]%sz!=0)) {
        cout << "Impossible\n";
        return 0;
    }
    if (balance[cycle[0]]>0) {
        for (long long int i=1; i<sz; i++) {
            ans2[cycle[i]]+=i*(balance[cycle[0]]/sz);
        }
        //output_cycle(n);
        //output_current(n);
        if (balance[cycle[0]]%sz!=0) {
            for (long long int i=1; i<sz; i++) {
                ans2[cycle[i]]+=min(i,(balance[cycle[0]]-1)%sz);
            }
            //output_current(n);
            //output_cycle(n);
        }
    }
    else {
        for (long long int i=sz-2; i>=0; i--) {
            ans2[cycle[i]]+=(sz-1-i)*(balance[cycle[sz-1]]/sz);
        }
        //output_cycle(n);
        //output_current(n);
        if (balance[cycle[sz-1]]%sz!=0) {
            for (long long int i=sz-2; i>=0; i--) {
                ans2[cycle[i]]+=min(sz-1-i,(balance[cycle[sz-1]]-1)%sz);
            }
            //output_current(n);
            //output_cycle(n);
        }
    }


    for (auto vr : cycle) {
        dfs(vr,true,-1,edges1,c);
        dfs3(vr,0,edges1,ans);
    }
    //output_current(n);
    for (auto vr : cycle) {
        dfs4(vr,ans2[vr]);
        ans2[vr]=0;
    }

    cout << "Possible\n";
    for (long long int i=0; i<n; i++) {
        cout << ans[i] << " ";
    }
    cout << endl ;
    //output_current(n);
    return 0;
}
