#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

const long long inf=1e18;

int n,m,a,b,parent[MAXN];
vector<int> v[MAXN],roots,tree;

long long c[MAXN],toadd[MAXN],sum[MAXN],total,w[MAXN];
long long ans[MAXN],sol[MAXN];

bool vis[MAXN];

void impossible(){
    cout<<"Impossible\n";
    exit(0);
}

void findpath(int x,int y){
    roots.push_back(x);
    if(x==y)return;

    findpath(parent[x],y);
}

void dfs(int x,int p){
    vis[x]=true;
    parent[x]=p;

    for(int i:v[x]){
        if(i==p)continue;

        if(!vis[i])dfs(i,x);
        else if(roots.empty()){
            findpath(x,i);
        }
    }
}

void dfs2(int x,int p){
    sum[x]=c[x];
    tree.push_back(x);

    for(int i:v[x]){
        if(vis[i] or i==p)continue;
        dfs2(i,x);

        sum[x]+=sum[i];
    }
}

void dfs3(int x,int p,long long curr){
    ans[x]+=curr;
    
    for(int i:v[x]){
        if(i==p or vis[i])continue;
        dfs3(i,x,curr+toadd[i]);
    }
}

void solve_tree(int x){
    tree.clear();
    dfs2(x,0);

    total=0;
    for(int f:tree){
        if(f==x)continue;

        if(sum[f]<0){
            toadd[f]+=-sum[f];
        }else{
            total+=sum[f];
            toadd[f]-=sum[f];
        }

        c[f]=0;
    }

    dfs3(x,0,total);
}

void find_cycle(){
    dfs(1,0);
    if(roots.empty())roots={1};
}

void solve_branches(){
    for(int i=1;i<=n;i++)vis[i]=false;
    for(int i:roots)vis[i]=true;

    for(int i:roots)solve_tree(i);
}

long long nums(long long to,long long mod,long long ost){
    long long tim=to/mod;
    if(to%mod>=ost)tim++;

    return (tim*(tim-1)/2)*mod + tim*ost;
}

void solve_cycle(){
    if(m==n-1){
        if(sum[1]<0)impossible();
        return;
    }

    roots.push_back(roots[0]);
    roots.push_back(roots[1]);

    for(int i=1;i<roots.size()-1;i++){
        c[roots[i]]=sum[roots[i]] + 2*ans[roots[i]] - ans[roots[i-1]] - ans[roots[i+1]];
    }

    for(int i=1;i<=n;i++){
        sol[i]=ans[i]; ans[i]=0;
    }

    roots.pop_back();
    roots.pop_back();

    long long sz=int(roots.size());

    for(int i=roots.size()-2;i>0;i--){
        long long curr=c[roots[i]];

        if(curr>0){
            for(int f=0;f<i;f++)ans[roots[f]]+=curr;
        }else{
            for(int f=i;f<sz;f++)ans[roots[f]]+=-curr;
        }

        c[roots[i-1]]+=curr;
        c[roots[0]]+=curr;

        c[roots.back()]-=curr;
        c[roots[i]]-=curr;
    }

    int X=roots[0],Y=roots.back();
    if(c[X]+c[Y]<0 or (c[X]+c[Y]==0 and abs(c[X])%sz!=0))impossible();

    if(c[X]<c[Y]){
        reverse(roots.begin(),roots.end());
        swap(X,Y);
    }

    if(c[Y]>=0)return;

    if(c[X]+c[Y]==0){
        long long tims=abs(c[Y])/sz;

        for(int i=0;i<roots.size();i++){
            ans[roots[i]]+=(long long) i*tims;
        }

        c[Y]+=tims*sz;
    }else{
        long long k=abs(c[Y]);
        long long add=k*(k+1)/2;

        for(int i=0;i<roots.size();i++){
            ans[roots[i]]+=-nums(k,sz,(k-i+sz)%sz)+add;
        }
    }
}

void fix_branches(){
    for(int i=1;i<=n;i++){
        vis[i]=false;
        toadd[i]=0;
    }

    for(int i:roots)vis[i]=true;

    for(int i:roots){
        dfs3(i,0,ans[i]);
        ans[i]/=2;
    }

    for(int i=1;i<=n;i++)sol[i]+=ans[i];
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;

    for(int i=1;i<=n;i++){
        cin>>c[i];
        w[i]=c[i];
    }

    for(int i=1;i<=m;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    find_cycle();
    solve_branches();
    solve_cycle();

    if(n==m)fix_branches();

    long long mins=sol[1];
    for(int i=1;i<=n;i++)mins=min(mins,sol[i]);
    for(int i=1;i<=n;i++)sol[i]-=mins;

    cout<<"Possible\n";
    for(int i=1;i<=n;i++){
        cout<<sol[i]<<" ";
    }
    cout<<"\n";

    return 0;
}
