/* the checker has three arguments:
   - first - name of the input file
   - second - name of the correct output file
   - third - name of the contestant output file */
#include<iostream>
#include<vector>

#define MAXN 100007
#define LL __int128

using namespace std;

const long long inf=1e18;

int n,m,a,b;
LL c[MAXN];

vector<int> v[MAXN];
LL sol[MAXN];

char ansL[50],contestantL[50];

void prnt(double points,const char message[]) {
    fprintf(stdout,"%f\n",points);
    fprintf(stderr,"%s\n",message);
    exit(0);
}

int main (int argc, char** argv) {
    if(argc<4)prnt(0,"Missing files!");

    FILE *in,*ans,*out;

    in=fopen(argv[1],"rt");
    if(!in)prnt(0,"Could not open input file!");
    ans=fopen(argv[2],"rt");
    if(!ans)prnt(0,"Could not open correct output file!");
    out=fopen(argv[3],"rt");
    if(!out)prnt(0,"Could not open contestant output file!");

    if(fscanf(in,"%d",&n)!=1)prnt(0,"Could not read input!");
    if(fscanf(in,"%d",&m)!=1)prnt(0,"Could not read input!");

    for(int i=1;i<=n;i++){
        if(fscanf(in,"%ld",&c[i])!=1)prnt(0,"Could not read input!");
    }
    
    for(int i=1;i<=m;i++){
        if(fscanf(in,"%d",&a)!=1)prnt(0,"Could not read input!");
        if(fscanf(in,"%d",&b)!=1)prnt(0,"Could not read input!");

        v[a].push_back(b);
        v[b].push_back(a);
    }

    if(fscanf(ans,"%s",&ansL)!=1)prnt(0,"Could not read answer!");
    if(fscanf(out,"%s",&contestantL)!=1)prnt(0,"Could not read output!");
        
    if(ansL[0]!=contestantL[0])prnt(0,"Wrong answer!");
    if(ansL[0]=='I')prnt(1,"Correct!");

    for(int i=1;i<=n;i++){
        if(fscanf(out,"%ld",&sol[i])!=1)prnt(0,"Could not read output!");
        if(sol[i]<0 or sol[i]>inf)prnt(0,"Invalid solution!");
    }

    for(int i=1;i<=n;i++){
        LL sum=0,sz=int(v[i].size());

        for(int f:v[i])sum+=sol[f];
        c[i] = c[i] + sz*sol[i] - sum;
    }

    for(int i=1;i<=n;i++){
        if(c[i]<0)prnt(0,"Invalid solution!");
    }

    prnt(1,"Correct!");

    return 0;
}

